package myCollection;
import java.util.Comparator;
//Using list -> sort all the element in order, by Collections.sort()
//Not all lists can be sorted.
//To sort a generic type of list:
//(1) implement Comparable
//(2) write a Comparator class for the objects we want to sort
public class AgeComparator implements Comparator<Student> {
	@Override
	public int compare(Student s1, Student s2) {
		if (s1 == s2) {
			return 0; // the same age
		} else if (s1 == null) {
			return -1; // s1 is older than s2
		} else if (s2 == null) {
			return 1; // s2 is older than s1
		} else {
			return s1.getAge() - s2.getAge();
		}
	}
}
