package myCollection;
public class GList<T> {
	private boolean empty;
	private T head;
	private GList<T> tail;
	public GList() {
		empty = true;
	}
	public GList(T head, GList<T> tail) {
		this.head = head;
		this.tail = tail;
	}
	public static GList nil() {
		return new GList();
	}
	public boolean empty() {
		return empty;
	}
	public T head() {
		return head;
	}
	public GList tail() {
		if (empty()) {
			throw new IllegalStateException("Trying to access tail of an empty list");
		}
		return tail;
	}
	@Override
	public String toString() {
		return toStringHelper(this, new java.util.ArrayList<T>());
	}
	private String toStringHelper(GList list, java.util.List<T> accumulator) {
		if (list == null) {
    		   throw new IllegalStateException("next element of list was null. " + 
    				   "Should either be another list or nil. " +
    				   "List till now: " + accumulator);
		} else if (list.empty()) {
		    return accumulator.toString();
		} else {
	    	accumulator.add((T)list.head());
	    	return toStringHelper(list.tail(), accumulator);
		}
	}
}
