package myCollection;
public class GList2<T extends Comparable<T>> {
	private boolean empty;
	private T head;
	private GList2<T> tail;
	public GList2() {
		empty = true;
	}
	public GList2(T head, GList2<T> tail) {
		this.head = head;
		this.tail = tail;
	}
	public static GList2 nil() {
		return new GList2();
	}
	public boolean empty() {
		return empty;
	}
	public T head() {
		return head;
	}
	public GList2 tail() {
		if (empty()) {
			throw new IllegalStateException("Trying to access tail" +
				" of an empty list");
		}
		return tail;
	}
	public <U extends Comparable<U>> boolean sorted(GList2<T> list) {
		if (list.empty() || list.tail().empty()) {
			return true;
		} else {
			T a = list.head();
			T b = (T) list.tail().head();
			int compareResult = a.compareTo(b);
			// 0 means they are equal
			// negative (<0) means a comes before b
			// positive (>0) means a comes after b
			if (compareResult > 0) {
				return false;
			} else {
				return sorted(list.tail());
			}
		}
	}
	@Override
	public String toString() {
		return toStringHelper(this, new java.util.ArrayList<T>());
	}
	private String toStringHelper(GList2 list, java.util.List<T> accumulator) {
		if (list == null) {
			throw new IllegalStateException("next element of list was null. " +
				"Should either be another list or nil. " + "List till now: " +
				accumulator);
		} else if (list.empty()) {
			return accumulator.toString();
		} else {
			accumulator.add((T) list.head());
			return toStringHelper(list.tail(), accumulator);
		}
	}
}
