package myCollection;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
public class MyCollection {
	public static <T> List<T> removeDuplicatesFromSortedList(List<T> input) {
		T previous = null;
		List<T> result = new ArrayList<>();
		result.add(input.get(0));
		Iterator<T> iter = input.iterator();
		while (iter.hasNext()) {
			T current = iter.next();
			if (previous != null && !previous.equals(current)) {
				result.add(current);
			}
			previous = current;
		}
		return result;
	}
	public static void main(String[] args) {
		System.out.println("Part 1: Iterator");
		Collection<String> myCollection = new ArrayList<>();
		myCollection.add("cat");
		Iterator<String> iterator = myCollection.iterator();
		while (iterator.hasNext()) {
			System.out.println(iterator.next());
		}
		System.out.printf("\nPart 2: Iterator is only read not change\n");
		Iterator<String> iterator2 = myCollection.iterator();
		while (iterator2.hasNext()) {
			String element = iterator2.next(); // there is no iterator2.prev()
			// Iterator only read the contents and not change it
			element += " and dog";
			System.out.println(element);
		}
		System.out.printf("\nPart 3: Removing duplicate values (sorted list only)\n");
		myCollection.add("cat");
		myCollection.add("dog");
		myCollection.add("monkey");
		myCollection.add("monkey");
		Iterator<String> iterator3 = myCollection.iterator();
		while (iterator3.hasNext()) {
			System.out.println(iterator3.next());
		}
		System.out.printf("\nAfter removing the duplicate values\n");
		Collection<String> myCollection2 = 
				removeDuplicatesFromSortedList((List<String>) myCollection);
		Iterator<String> iterator4 = myCollection2.iterator();
		while (iterator4.hasNext()) {
			System.out.println(iterator4.next());
		}
		System.out.printf("\nPart 4: Iterable\n");
		Collection<Integer> it = new ArrayList<>();
		it.add(3);
		it.add(5);
		it.add(7);
		int sum = 0;
		for (Integer i : it) {
			sum += i;
		}
		System.out.println("sum = " + sum);
		System.out.printf("\nPart 5: Comparator\n");
		Collection<Student> students = new ArrayList<>();
		Student s = new Student(15);
		students.add(s);
		Student s1 = new Student(20);
		students.add(s1);
		Student s2 = new Student(12);
		students.add(s2);
		Iterator<Student> itStudents = students.iterator();
		while (itStudents.hasNext()) {
			System.out.println(itStudents.next().getAge());
		}
		AgeComparator age = new AgeComparator();
		System.out.printf("Age difference between s1 (age %d) and s2 (age %d) = %d\n",
				s1.getAge(), s2.getAge(), age.compare(s1, s2));
		System.out.println("After sort is called, the list of student becomes:");
		Collections.sort((List<Student>) students, new AgeComparator());
		Iterator<Student> itStudents2 = students.iterator();
		while (itStudents2.hasNext()) {
			System.out.println(itStudents2.next().getAge());
		}
	}
}
